<template>
  <v-btn-toggle
    v-model="model"
    :divided="divided"
    :mandatory="mandatory"
    :variant="variant"
    :color="color"
    :density="density"
    :border="border"
    :rounded="rounded"
    :multiple="multiple"
    @update:model-value="update"
  >
    <svn-pro-icon-button
      v-for="item in items"
      :key="item?.value"
      :value="item?.value"
      :icon="item?.icon"
      :rounded="'0'"
      :variant="variant"
      :color="color"
      :disabled="item?.disabled"
    />
  </v-btn-toggle>
</template>

<script setup>
import { ref, watch, onMounted } from 'vue';
import SvnProIconButton from './SvnProIconButton.vue';
import {
  ButtonVariants,
  ComponentDensities,
  SizeEnum,
  ComponentBorderRadiuses,
  ComponentBorders,
} from '../../constants/types';

const props = defineProps({
  modelValue: {
    type: [Array, Object, String],
    default: undefined,
  },
  items: {
    type: Array,
    default: () => [],
    validator: (value) => Array.isArray(value),
  },
  multiple: {
    type: Boolean,
    default: false,
  },
  divided: {
    type: Boolean,
    default: true,
  },
  mandatory: {
    type: Boolean,
    default: true,
  },
  variant: {
    type: String,
    default: ButtonVariants.DEFAULT,
    validator: (value) =>
      Object.values(ButtonVariants).find((element) => element === value),
  },
  rounded: {
    type: String,
    default: ComponentBorderRadiuses.DEFAULT,
    validator: (value) =>
      Object.values(ComponentBorderRadiuses).find(
        (element) => element === value
      ),
  },
  border: {
    type: String,
    default: ComponentBorders.FALSE,
    validator: (value) =>
      Object.values(ComponentBorders).find((element) => element === value),
  },
  color: {
    type: String,
    default: 'primary',
  },
  density: {
    type: String,
    default: ComponentDensities.DEFAULT,
    validator: (value) =>
      Object.values(ComponentDensities).find((element) => element === value),
  },
  size: {
    type: String,
    default: SizeEnum.DEFAULT,
    validator: (value) =>
      Object.values(SizeEnum).find((element) => element === value),
  },
});

const emit = defineEmits(['update:modelValue']);

const model = ref(null);

onMounted(() => {
  model.value = props?.modelValue;
});

const update = () => {
  emit('update:modelValue', model?.value);
};

watch(props, (newValue) => {
  if (newValue?.modelValue) {
    model.value = newValue?.modelValue;
  }
});
</script>
